      SUBROUTINE QSE1R(RINT,A,B,F,R,E,N,IERR)
         INTEGER IERR,N
         REAL A,B,E,F,R,RINT
         DIMENSION RINT(2)
         INTEGER K,K1,M,NMAX
         REAL A1,A2,B1,B2,B3,C1,C2,C3,D1,D2,D3,E1,E2,E3,G1,G2,H,H1,H2,
     1        H3,PI,R1,RM,RN,RP,RQ,RT,SYS001,T,T1,T2,X,X0,X1,X2,Y,Z
         DIMENSION R1(10),Z(28)
         EQUIVALENCE (SYS001,PI)
         DATA NMAX/1048576/,SYS001/3.141593/
       N = IABS(N)
       IF (N .EQ. 0) GO TO 130
          IERR = 0
          PI = SYS001
          K1 = 0
          H = B - A
          IF (N .LT. NMAX) GO TO 10
             N = -1
             IERR = 65
             CALL UTQS11(IERR,10)
             GO TO 130
   10  CONTINUE
       Z(9) = R*A
       Z(10) = COS(Z(9))
       Z(11) = SIN(Z(9))
       Z(13) = R*H
       Z(14) = COS(Z(13))
       Z(15) = SIN(Z(13))
       R1(1) = F(A)
       R1(6) = F(B)
   20  CONTINUE
       H1 = 1./N
       H2 = H/N
       H3 = 32.*N
       Z(1) = Z(13)/(2.*N)
       Z(28) = ABS(Z(1))
       IF (Z(28) - 0.25) 30, 30, 100
   30  CONTINUE
       Z(2) = Z(1)*Z(1)
       Z(3) = Z(1)*Z(2)
       Z(4) = Z(2)*Z(2)
       Z(5) = Z(2)*Z(3)
       Z(6) = Z(3)*Z(3)
       Z(7) = Z(3)*Z(4)
       Z(8) = Z(4)*Z(4)
       A1 = Z(1)/3. + Z(3)/45. + 2.*Z(5)/945. + Z(7)/4725.
       B1 = -(1./3. + Z(2)/15. + 2.*Z(4)/189. + Z(6)/675. + 2.*Z(8)
     1      /10395.)
       C1 = -(Z(1)/15. + 4.*Z(3)/189. + Z(5)/225. + 6763.*Z(7)/
     1      8553600.)
       D1 = 1./45. + 4.*Z(2)/189. + Z(4)/135. + 6071.*Z(6)/
     1      3421440 + 8781007.*Z(8)/25147584000.
       E1 = 2.*Z(1)/189. + Z(3)/135. + 9289.*Z(5)/3421440. + 63967.*
     1      Z(7)/78586200.
   40  CONTINUE
       R1(2) = F(A+H2)
       R1(3) = F(A+2.*H2)
       R1(4) = F(A+3.*H2)
       R1(5) = F(A+4.*H2)
       R1(7) = F(A+H*(1.-H1))
       R1(8) = F(A+H*(1.-2.*H1))
       R1(9) = F(A+H*(1.-3.*H1))
       R1(10) = F(A+H*(1.-4.*H1))
       B2 = -25.*R1(1)/12. + 4.*R1(2) - 3.*R1(3) + 4.*R1(4)/3. -
     1      0.25*R1(5)
       C2 = 35.*R1(1)/12. - 26.*R1(2)/3. + 9.5*R1(3) - 14.*R1(4)
     1      /3. + 11.*R1(5)/12.
       D2 = -2.5*R1(1) + 9.*R1(2) - 12.*R1(3) + 7.*R1(4) - 1.5*R1(5)
       E2 = R1(1) - 4.*R1(2) + 6.*R1(3) - 4.*R1(4) + R1(5)
       B3 = 25.*R1(6)/12. - 4.*R1(7) + 3.*R1(8) - 4.*R1(9)/3. +
     1      0.25*R1(10)
       C3 = 35.*R1(6)/12. - 26.*R1(7)/3. + 9.5*R1(8) - 14.*R1(9)
     1      /3. + 11.*R1(10)/12.
       D3 = 2.5*R1(6) - 9.*R1(7) + 12.*R1(8) - 7.*R1(9) + 1.5*R1(10)
       E3 = R1(6) - 4.*R1(7) + 6.*R1(8) - 4.*R1(9) + R1(10)
       RM = (B1*B2 + D1*D2/4.)/2.
       RN = (C1*C2 + E1*E2/4.)/4.
       RP = (B1*B3 + D1*D3/4.)/2.
       RQ = (C1*C3 + E1*E3/4.)/4.
       X = (R1(1) - RM + (A1*R1(6) + RQ)*Z(15) + (R1(6) + RP)*
     1     Z(14))/2.
       Y = (A1*R1(1) + RN + (R1(6) + RP)*Z(15) - (A1*R1(6) + RQ)*
     1     Z(14))/2.
       M = N - 5
       Z(12) = Z(13)/N
       X = X + R1(2)*COS(Z(12)) + R1(3)*COS(2.*Z(12)) + R1(4)
     1     *COS(3.*Z(12)) + R1(5)*COS(4.*Z(12)) + R1(10)*COS((N-4.)*
     2     Z(12)) + R1(9)*COS((N-3.)*Z(12)) + R1(8)*COS((N-2.)*Z(12)
     3     ) + R1(7)*COS((N-1.)*Z(12))
       Y = Y + R1(2)*SIN(Z(12)) + R1(3)*SIN(2.*Z(12)) + R1(4)
     1     *SIN(3.*Z(12)) + R1(5)*SIN(4.*Z(12)) + R1(10)*SIN((N-4.)*
     2     Z(12)) + R1(9)*SIN((N-3.)*Z(12)) + R1(8)*SIN((N-2.)*Z(12)
     3     ) + R1(7)*SIN((N-1.)*Z(12))
       DO 50 K = 5, M
          A2 = F(A+H2*K)
          X = X + A2*COS(Z(12)*K)
          Y = Y + A2*SIN(Z(12)*K)
   50  CONTINUE
       RINT(1) = (X*Z(10) - Y*Z(11))*H2
       RINT(2) = (Y*Z(10) + X*Z(11))*H2
       T1 = (E1*E3*Z(15))/H3
       T2 = (E1*E2 - E1*E3*Z(14))/H3
       T = SQRT(T1**2+T2**2)
       IF (E) 130, 130, 70
   60  CONTINUE
       IF (T - E) 130, 130, 80
   70  CONTINUE
       K1 = K1 + 1
       IF (K1 - 1) 90, 60, 90
   80  CONTINUE
       G1 = RINT(1)
       G2 = RINT(2)
       N = 2*N
       IF (N .LT. NMAX) GO TO 20
          N = -1
          IERR = 65
          CALL UTQS11(IERR,10)
          GO TO 130
   90  CONTINUE
       RT = SQRT((RINT(1)-G1)**2 + (RINT(2) - G2)**2)
       IF (AMIN1(T,RT) - E) 130, 130, 80
  100  CONTINUE
       X0 = Z(28)/PI
       X1 = INT(X0+0.5)
       X2 = INT(X0)
       IF (ABS(X0-X1) - 1./(4.*PI)) 110, 110, 120
  110  CONTINUE
       N = INT(ABS(Z(13)/(2.*PI*(X2-0.5))))
       IF (N .LT. NMAX) GO TO 20
          N = -1
          IERR = 65
          CALL UTQS11(IERR,10)
          GO TO 130
  120  CONTINUE
       Z(16) = 1./Z(1)
       Z(17) = Z(16)*Z(16)
       Z(18) = Z(16)*Z(17)
       Z(19) = Z(17)*Z(17)
       Z(20) = Z(16)*Z(19)
       Z(21) = SIN(Z(1))
       Z(22) = Z(21)*Z(21)
       Z(23) = Z(21)*Z(22)
       Z(24) = Z(22)*Z(22)
       Z(25) = Z(21)*Z(24)
       Z(26) = COS(Z(1))
       Z(27) = Z(26)*Z(26)
       A1 = Z(16) - Z(26)/Z(21)
       B1 = Z(17) - 1./Z(22)
       C1 = Z(26)/Z(23) - Z(18)
       D1 = (1. + 2.*Z(27))/(3.*Z(24)) - Z(19)
       E1 = Z(20) - Z(26)*(2. + Z(27))/(3.*Z(25))
       GO TO 40
  130  RETURN
      END
